import { Response, Request, NextFunction } from "express";
export declare const errorHandler: (response: Pick<Response, "end" | "finished" | "header" | "writable" | "json" | "get" | "set" | "removeListener" | "pipe" | "connection" | "clearCookie" | "app" | "setTimeout" | "statusCode" | "statusMessage" | "destroy" | "_destroy" | "addListener" | "emit" | "on" | "once" | "prependListener" | "prependOnceListener" | "off" | "removeAllListeners" | "setMaxListeners" | "getMaxListeners" | "listeners" | "rawListeners" | "eventNames" | "listenerCount" | "status" | "sendStatus" | "links" | "send" | "jsonp" | "sendFile" | "sendfile" | "download" | "contentType" | "type" | "format" | "attachment" | "headersSent" | "cookie" | "location" | "redirect" | "render" | "charset" | "vary" | "append" | "req" | "assignSocket" | "detachSocket" | "writeContinue" | "writeHead" | "upgrading" | "chunkedEncoding" | "shouldKeepAlive" | "useChunkedEncodingByDefault" | "sendDate" | "setHeader" | "getHeader" | "getHeaders" | "getHeaderNames" | "hasHeader" | "removeHeader" | "addTrailers" | "flushHeaders" | "writableHighWaterMark" | "writableLength" | "_write" | "_writev" | "_final" | "write" | "setDefaultEncoding" | "cork" | "uncork">, err: Error & {
    status?: number | undefined;
}) => void;
export declare const successHandler: (response: Pick<Response, "end" | "finished" | "header" | "writable" | "json" | "get" | "set" | "removeListener" | "pipe" | "connection" | "clearCookie" | "app" | "setTimeout" | "statusCode" | "statusMessage" | "destroy" | "_destroy" | "addListener" | "emit" | "on" | "once" | "prependListener" | "prependOnceListener" | "off" | "removeAllListeners" | "setMaxListeners" | "getMaxListeners" | "listeners" | "rawListeners" | "eventNames" | "listenerCount" | "status" | "sendStatus" | "links" | "send" | "jsonp" | "sendFile" | "sendfile" | "download" | "contentType" | "type" | "format" | "attachment" | "headersSent" | "cookie" | "location" | "redirect" | "render" | "charset" | "vary" | "append" | "req" | "assignSocket" | "detachSocket" | "writeContinue" | "writeHead" | "upgrading" | "chunkedEncoding" | "shouldKeepAlive" | "useChunkedEncodingByDefault" | "sendDate" | "setHeader" | "getHeader" | "getHeaders" | "getHeaderNames" | "hasHeader" | "removeHeader" | "addTrailers" | "flushHeaders" | "writableHighWaterMark" | "writableLength" | "_write" | "_writev" | "_final" | "write" | "setDefaultEncoding" | "cork" | "uncork">, data: any) => void;
export declare const makeAsyncHandler: <T>() => <Req, Res>(fn: (req: Pick<Request, "push" | "host" | "complete" | "header" | "param" | "path" | "pause" | "next" | "readable" | "resume" | "get" | "removeListener" | "pipe" | "unpipe" | "trailers" | "headers" | "connection" | "accepts" | "acceptsCharsets" | "acceptsEncodings" | "acceptsLanguages" | "range" | "accepted" | "is" | "protocol" | "secure" | "ip" | "ips" | "subdomains" | "hostname" | "fresh" | "stale" | "xhr" | "cookies" | "method" | "clearCookie" | "route" | "signedCookies" | "originalUrl" | "url" | "baseUrl" | "app" | "res" | "httpVersion" | "httpVersionMajor" | "httpVersionMinor" | "rawHeaders" | "rawTrailers" | "setTimeout" | "statusCode" | "statusMessage" | "socket" | "destroy" | "readableHighWaterMark" | "readableLength" | "_read" | "read" | "setEncoding" | "isPaused" | "unshift" | "wrap" | "_destroy" | "addListener" | "emit" | "on" | "once" | "prependListener" | "prependOnceListener" | "off" | "removeAllListeners" | "setMaxListeners" | "getMaxListeners" | "listeners" | "rawListeners" | "eventNames" | "listenerCount"> & Req & T, res: Pick<Response, "end" | "finished" | "header" | "writable" | "json" | "get" | "set" | "removeListener" | "pipe" | "connection" | "clearCookie" | "app" | "setTimeout" | "statusCode" | "statusMessage" | "destroy" | "_destroy" | "addListener" | "emit" | "on" | "once" | "prependListener" | "prependOnceListener" | "off" | "removeAllListeners" | "setMaxListeners" | "getMaxListeners" | "listeners" | "rawListeners" | "eventNames" | "listenerCount" | "status" | "sendStatus" | "links" | "send" | "jsonp" | "sendFile" | "sendfile" | "download" | "contentType" | "type" | "format" | "attachment" | "headersSent" | "cookie" | "location" | "redirect" | "render" | "charset" | "vary" | "append" | "req" | "assignSocket" | "detachSocket" | "writeContinue" | "writeHead" | "upgrading" | "chunkedEncoding" | "shouldKeepAlive" | "useChunkedEncodingByDefault" | "sendDate" | "setHeader" | "getHeader" | "getHeaders" | "getHeaderNames" | "hasHeader" | "removeHeader" | "addTrailers" | "flushHeaders" | "writableHighWaterMark" | "writableLength" | "_write" | "_writev" | "_final" | "write" | "setDefaultEncoding" | "cork" | "uncork">) => Promise<Res>) => (request: Pick<Request, "push" | "host" | "complete" | "header" | "param" | "path" | "pause" | "next" | "readable" | "resume" | "get" | "removeListener" | "pipe" | "unpipe" | "trailers" | "headers" | "connection" | "accepts" | "acceptsCharsets" | "acceptsEncodings" | "acceptsLanguages" | "range" | "accepted" | "is" | "protocol" | "secure" | "ip" | "ips" | "subdomains" | "hostname" | "fresh" | "stale" | "xhr" | "cookies" | "method" | "clearCookie" | "route" | "signedCookies" | "originalUrl" | "url" | "baseUrl" | "app" | "res" | "httpVersion" | "httpVersionMajor" | "httpVersionMinor" | "rawHeaders" | "rawTrailers" | "setTimeout" | "statusCode" | "statusMessage" | "socket" | "destroy" | "readableHighWaterMark" | "readableLength" | "_read" | "read" | "setEncoding" | "isPaused" | "unshift" | "wrap" | "_destroy" | "addListener" | "emit" | "on" | "once" | "prependListener" | "prependOnceListener" | "off" | "removeAllListeners" | "setMaxListeners" | "getMaxListeners" | "listeners" | "rawListeners" | "eventNames" | "listenerCount"> & Req & T, response: Pick<Response, "end" | "finished" | "header" | "writable" | "json" | "get" | "set" | "removeListener" | "pipe" | "connection" | "clearCookie" | "app" | "setTimeout" | "statusCode" | "statusMessage" | "destroy" | "_destroy" | "addListener" | "emit" | "on" | "once" | "prependListener" | "prependOnceListener" | "off" | "removeAllListeners" | "setMaxListeners" | "getMaxListeners" | "listeners" | "rawListeners" | "eventNames" | "listenerCount" | "status" | "sendStatus" | "links" | "send" | "jsonp" | "sendFile" | "sendfile" | "download" | "contentType" | "type" | "format" | "attachment" | "headersSent" | "cookie" | "location" | "redirect" | "render" | "charset" | "vary" | "append" | "req" | "assignSocket" | "detachSocket" | "writeContinue" | "writeHead" | "upgrading" | "chunkedEncoding" | "shouldKeepAlive" | "useChunkedEncodingByDefault" | "sendDate" | "setHeader" | "getHeader" | "getHeaders" | "getHeaderNames" | "hasHeader" | "removeHeader" | "addTrailers" | "flushHeaders" | "writableHighWaterMark" | "writableLength" | "_write" | "_writev" | "_final" | "write" | "setDefaultEncoding" | "cork" | "uncork">) => Promise<void>;
export declare const makeAsyncNextHandler: <T>() => <Req>(fn: (req: Pick<Request, "push" | "host" | "complete" | "header" | "param" | "path" | "pause" | "next" | "readable" | "resume" | "get" | "removeListener" | "pipe" | "unpipe" | "trailers" | "headers" | "connection" | "accepts" | "acceptsCharsets" | "acceptsEncodings" | "acceptsLanguages" | "range" | "accepted" | "is" | "protocol" | "secure" | "ip" | "ips" | "subdomains" | "hostname" | "fresh" | "stale" | "xhr" | "cookies" | "method" | "clearCookie" | "route" | "signedCookies" | "originalUrl" | "url" | "baseUrl" | "app" | "res" | "httpVersion" | "httpVersionMajor" | "httpVersionMinor" | "rawHeaders" | "rawTrailers" | "setTimeout" | "statusCode" | "statusMessage" | "socket" | "destroy" | "readableHighWaterMark" | "readableLength" | "_read" | "read" | "setEncoding" | "isPaused" | "unshift" | "wrap" | "_destroy" | "addListener" | "emit" | "on" | "once" | "prependListener" | "prependOnceListener" | "off" | "removeAllListeners" | "setMaxListeners" | "getMaxListeners" | "listeners" | "rawListeners" | "eventNames" | "listenerCount"> & Req & T, res: Pick<Response, "end" | "finished" | "header" | "writable" | "json" | "get" | "set" | "removeListener" | "pipe" | "connection" | "clearCookie" | "app" | "setTimeout" | "statusCode" | "statusMessage" | "destroy" | "_destroy" | "addListener" | "emit" | "on" | "once" | "prependListener" | "prependOnceListener" | "off" | "removeAllListeners" | "setMaxListeners" | "getMaxListeners" | "listeners" | "rawListeners" | "eventNames" | "listenerCount" | "status" | "sendStatus" | "links" | "send" | "jsonp" | "sendFile" | "sendfile" | "download" | "contentType" | "type" | "format" | "attachment" | "headersSent" | "cookie" | "location" | "redirect" | "render" | "charset" | "vary" | "append" | "req" | "assignSocket" | "detachSocket" | "writeContinue" | "writeHead" | "upgrading" | "chunkedEncoding" | "shouldKeepAlive" | "useChunkedEncodingByDefault" | "sendDate" | "setHeader" | "getHeader" | "getHeaders" | "getHeaderNames" | "hasHeader" | "removeHeader" | "addTrailers" | "flushHeaders" | "writableHighWaterMark" | "writableLength" | "_write" | "_writev" | "_final" | "write" | "setDefaultEncoding" | "cork" | "uncork">, next: NextFunction) => Promise<void>) => (request: Pick<Request, "push" | "host" | "complete" | "header" | "param" | "path" | "pause" | "next" | "readable" | "resume" | "get" | "removeListener" | "pipe" | "unpipe" | "trailers" | "headers" | "connection" | "accepts" | "acceptsCharsets" | "acceptsEncodings" | "acceptsLanguages" | "range" | "accepted" | "is" | "protocol" | "secure" | "ip" | "ips" | "subdomains" | "hostname" | "fresh" | "stale" | "xhr" | "cookies" | "method" | "clearCookie" | "route" | "signedCookies" | "originalUrl" | "url" | "baseUrl" | "app" | "res" | "httpVersion" | "httpVersionMajor" | "httpVersionMinor" | "rawHeaders" | "rawTrailers" | "setTimeout" | "statusCode" | "statusMessage" | "socket" | "destroy" | "readableHighWaterMark" | "readableLength" | "_read" | "read" | "setEncoding" | "isPaused" | "unshift" | "wrap" | "_destroy" | "addListener" | "emit" | "on" | "once" | "prependListener" | "prependOnceListener" | "off" | "removeAllListeners" | "setMaxListeners" | "getMaxListeners" | "listeners" | "rawListeners" | "eventNames" | "listenerCount"> & Req & T, response: Pick<Response, "end" | "finished" | "header" | "writable" | "json" | "get" | "set" | "removeListener" | "pipe" | "connection" | "clearCookie" | "app" | "setTimeout" | "statusCode" | "statusMessage" | "destroy" | "_destroy" | "addListener" | "emit" | "on" | "once" | "prependListener" | "prependOnceListener" | "off" | "removeAllListeners" | "setMaxListeners" | "getMaxListeners" | "listeners" | "rawListeners" | "eventNames" | "listenerCount" | "status" | "sendStatus" | "links" | "send" | "jsonp" | "sendFile" | "sendfile" | "download" | "contentType" | "type" | "format" | "attachment" | "headersSent" | "cookie" | "location" | "redirect" | "render" | "charset" | "vary" | "append" | "req" | "assignSocket" | "detachSocket" | "writeContinue" | "writeHead" | "upgrading" | "chunkedEncoding" | "shouldKeepAlive" | "useChunkedEncodingByDefault" | "sendDate" | "setHeader" | "getHeader" | "getHeaders" | "getHeaderNames" | "hasHeader" | "removeHeader" | "addTrailers" | "flushHeaders" | "writableHighWaterMark" | "writableLength" | "_write" | "_writev" | "_final" | "write" | "setDefaultEncoding" | "cork" | "uncork">, next: NextFunction) => Promise<void>;
